local Sushi = LibStub('Sushi-2.0')
local Button = Sushi:NewWidgetClass('Button', {
	frameType = 'Button',
	template = 'UIPanelButtonTemplate2',
	insets = {left = 11, right = 11, bottom = 5},
	version = 1,
})

if not Button then
	return
end


--[[ Events ]]--

function Button:OnCreate()
	self:SetScript('OnClick', self.OnClick)
	self:SetScript('OnEnter', self.OnEnter)
	self:SetScript('OnLeave', self.OnLeave)
	self.SetLabel = self.SetText
	self.GetLabel = self.GetText
end

function Button:OnRelease()
	self:SetDescription(nil)
	self:SetDisabled(nil)
	self:SetSmall(nil)
	self:SetText(nil)
end

function Button:OnClick()
	PlaySound('igMainMenuOptionCheckBoxOn')
	self:FireCallback('OnUpdate')
	self:FireCallback('OnClick')
end


--[[ Text ]]--

function Button:SetText(text)
	self:GetFontString():SetText(text)
	self:SetWidth(self:GetTextWidth() + 15)
end

function Button:SetDisabled(disabled)
	if not disabled then
		self:Enable()
	else
		self:Disable()
	end
end

function Button:SetSmall(small)
	if small then
		self:SetHighlightFontObject('GameFontHighlightSmall')
		self:SetDisabledFontObject('GameFontDisableSmall')
		self:SetNormalFontObject('GameFontNormalSmall')
	else
		self:SetHighlightFontObject('GameFontHighlight')
		self:SetDisabledFontObject('GameFontDisable')
		self:SetNormalFontObject('GameFontNormal')
	end
end

function Button:IsSmall(small)
	return self:GetNormalFontObject() == 'GameFontNormalSmall'
end


--[[ Tooltip ]]--

function Button:SetDescription(desc)
	self.desc = desc
end

function Button:GetDescription()
	return self.desc
end

function Button:OnEnter()
	local desc = self:GetDescription()
	if desc then
		GameTooltip:SetOwner(self, 'ANCHOR_RIGHT')
		GameTooltip:SetText(desc, nil, nil, nil, nil, 1)
		GameTooltip:Show()
	end
end

function Button:OnLeave()
	if self:GetDescription() then
		GameTooltip:Hide()
	end
end


--[[ Embedding ]]--

Button:UpdateEmbeds()